ALTER TABLE FW_SYS_STAT_PVSS_PROJECT DROP CONSTRAINT  REDU_ID_FK;
ALTER TABLE FW_SYS_STAT_PVSS_PROJECT ADD CONSTRAINT REDU_ID_FK FOREIGN KEY (REDU_COMPUTER_ID) REFERENCES FW_SYS_STAT_COMPUTER (ID) ON DELETE SET NULL;
ALTER TABLE FW_SYS_STAT_PVSS_PROJECT DROP CONSTRAINT  PROJECT_COMPUTER_ID_FK;
ALTER TABLE FW_SYS_STAT_PVSS_PROJECT ADD CONSTRAINT PROJECT_COMPUTER_ID_FK FOREIGN KEY (COMPUTER_ID) REFERENCES FW_SYS_STAT_COMPUTER (ID) ON DELETE SET NULL ;
CREATE or REPLACE TRIGGER FW_SYS_STAT_COMPUTER_AC
	AFTER UPDATE OF VALID_UNTIL ON FW_SYS_STAT_COMPUTER
	FOR EACH ROW
DECLARE cID number;
BEGIN
	cID := :old.id;
	IF (UPDATING('VALID_UNTIL') AND :new.valid_until is not null) THEN
	    UPDATE  fw_sys_stat_pvss_project SET redu_computer_id = null
	    WHERE id in (SELECT id FROM fw_sys_stat_pvss_project where redu_computer_id=cID);
	    UPDATE  fw_sys_stat_pvss_project SET computer_id = null
	    WHERE id in (SELECT id FROM fw_sys_stat_pvss_project where computer_id=cID);
	END IF;
END;
/
--Upgrade Schema version
CREATE OR REPLACE VIEW fw_sys_stat_schema (version) AS
	SELECT '4.1.6'
	FROM dual;

