CREATE OR REPLACE PACKAGE fw_sys_stat_sas_target_db_pkg AS
  PROCEDURE CREATE_PROJECT(PROJ_NAME IN VARCHAR2,
                         SYSTEM_NAME IN VARCHAR2,
                         SYSTEM_NUMBER  IN NUMBER,
                         PMON_PORT IN NUMBER,
                         DATA_PORT IN NUMBER,
                         EVENT_PORT IN NUMBER,
                         DIST_PORT IN NUMBER,
                         REDU_PORT IN NUMBER,
                         SPLIT_PORT IN NUMBER,
                         HOSTNAME IN VARCHAR2,
                         REDU_HOSTNAME IN VARCHAR2,
                         IS_REDUNDANT IN BOOLEAN,
                         REDU_PEER IN NUMBER,
                         RESPONSIBLE IN VARCHAR2,
                         PVSS_VERSION IN VARCHAR2,
                         CREATED_BY IN VARCHAR2,
                         SERVICE_ACCOUNT IN VARCHAR2,
                         JIRA_ISSUE IN VARCHAR2);

  FUNCTION GET_OR_CREATE_COMPUTER(COMPUTER_HOSTNAME IN VARCHAR2) RETURN NUMBER;

  PROCEDURE UPDATE_PROJECT_INFO(PROJECT_ID IN NUMERIC,
                                RESPONSIBLE IN VARCHAR2,
                                STATUS IN VARCHAR2,
                                COMMENT_TEXT IN VARCHAR2,
                                JIRA_ISSUE IN VARCHAR2,
                                WCCOA_URL IN VARCHAR2,
                                INFO_URL IN VARCHAR2,
                                APP_DOMAIN IN VARCHAR2,
                                SERVICE_ACCOUNT IN VARCHAR2);
                                
  PROCEDURE DELETE_PROJECT(PROJECT_ID IN NUMERIC);
  PROCEDURE DELETE_SYSTEM(SYSTEM_ID IN NUMERIC);
  PROCEDURE DELETE_COMPUTER(COMPUTER_ID IN NUMERIC);
  
  PROCEDURE INVALIDATE_PROJECT(PROJECT_ID IN NUMERIC);
  PROCEDURE INVALIDATE_SYSTEM(SYSTEM_ID IN NUMERIC);
  
  FUNCTION IS_DOMAIN_RESPONSIBLE(USERNAME IN VARCHAR2, PROJECT_ID IN NUMERIC) RETURN BOOLEAN;

  FUNCTION GET_NEW_SYSTEM_NUMBER RETURN NUMBER;

END fw_sys_stat_sas_target_db_pkg;
